# Test

Please try to perform following command:

```sh
# setup the environment variables in the root directory of the tool
$ source tool/init_env.sh

# compile the program and get bit code
$ cd $ROOT_DIR/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792
$ ./cleanDIR.sh
$ clang++ -g -emit-llvm -c ./2013-1792.cpp -o 2013-1792.bc

# perform static analysis
$ $ROOT_DIR/tool/staticAnalysis/staticAnalysis.sh 2013-1792

# complie the instrumented program with ASAN
$ export Con_PATH=$ROOT_DIR/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792/ConConfig.2013-1792
$ $ROOT_DIR/tool/staticAnalysis/DBDS-INSTRU/dbds-clang-fast++ -g -fsanitize=address ./2013-1792.cpp -o 2013-1792 -lpthread -ldl


# perform DBDS
$ $ROOT_DIR/tool/DBDS/run_PDS.py -d 2 ./2013-1792
```

Then you will get the results.

```sh
Start Testing!
test 0001
test 0002
...
```

The NDP ASAN output:
```sh
AddressSanitizer:DEADLYSIGNAL
=================================================================
==102009==ERROR: AddressSanitizer: SEGV on unknown address 0x000000000000 (pc 0x0000004c94ab bp 0x000000000000 sp 0x7f1b14556ea0 T1)
==102009==The signal is caused by a WRITE memory access.
==102009==Hint: address points to the zero page.
thread 2: install_user_keyrings done
    #0 0x4c94aa  (/ConcurrencyFuzzer/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792/2013-1792+0x4c94aa)
    #1 0x4c984e  (/ConcurrencyFuzzer/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792/2013-1792+0x4c984e)
    #2 0x7f1b181286b9  (/lib/x86_64-linux-gnu/libpthread.so.0+0x76b9)
    #3 0x7f1b171b14dc  (/lib/x86_64-linux-gnu/libc.so.6+0x1074dc)

AddressSanitizer can not provide additional info.
SUMMARY: AddressSanitizer: SEGV (/ConcurrencyFuzzer/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792/2013-1792+0x4c94aa)
Thread T1 created by T0 here:
    #0 0x47f34a  (/ConcurrencyFuzzer/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792/2013-1792+0x47f34a)
    #1 0x4c9a35  (/ConcurrencyFuzzer/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792/2013-1792+0x4c9a35)
    #2 0x7f1b170ca83f  (/lib/x86_64-linux-gnu/libc.so.6+0x2083f)

==102009==ABORTING

```

Use `addr2line -e ./2013-1792 0x4c94aa` and `addr2line -e ./2013-1792 0x4c984e` to see the debug info
```
/ConcurrencyFuzzer/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792/./2013-1792.cpp:92
/ConcurrencyFuzzer/evaluation/ConVul-CVE-Benchmarks/CVE-2013-1792/./2013-1792.cpp:248
```
