#!/bin/bash

# For Mac
if [ $(command uname) == "Darwin" ]; then
	if ! [ -x "$(command -v greadlink)"  ]; then
		brew install coreutils
	fi
	BIN_PATH=$(greadlink -f "$0")
	ROOT_DIR=$(dirname $(dirname $(dirname $(dirname $BIN_PATH))))
# For Linux
else
	BIN_PATH=$(readlink -f "$0")
	ROOT_DIR=$(dirname $(dirname $(dirname $(dirname $BIN_PATH))))
fi

export ROOT_DIR=${ROOT_DIR}
export PATH=${ROOT_DIR}/clang+llvm/bin:${ROOT_DIR}/tool/SVF/Release-build/bin:$PATH
export LD_LIBRARY_PATH=${ROOT_DIR}/clang+llvm/lib${LD_LIBRARY_PATH:+:$LD_LIBRARY_PATH}

echo "Installation completed. Everything's fine!"

set -eux

# CVE-2015-7550
cd $ROOT_DIR/evaluation/ConVul-CVE-Benchmarks/CVE-2015-7550
./cleanDIR.sh
clang++ -g -emit-llvm -c ./2015-7550.cpp -o 2015-7550.bc
$ROOT_DIR/tool/staticAnalysis/staticAnalysis.sh 2015-7550
export Con_PATH=$ROOT_DIR/evaluation/ConVul-CVE-Benchmarks/CVE-2015-7550/ConConfig.2015-7550
$ROOT_DIR/tool/staticAnalysis/DBDS-INSTRU/dbds-clang-fast++ -g -fsanitize=address ./2015-7550.cpp -o 2015-7550 -lpthread -ldl
